#include <Include/PlatformDefinitions.hpp>
#include <util/PlatformUtils.hpp>

#include <stdio.h>

#include "Rxslt.hpp"

#include "RxslFunction.hpp"
#include "SInitFunction.hpp"


int
registerSFunctions(void)
{
  const XalanDOMString	theNamespace("http://cm.bell-labs.com/stat/S4");

#if 0
  const XalanDOMString call("call");
	XSLTProcessorEnvSupportDefault::installExternalFunctionGlobal(
		theNamespace,
		call,
		FunctionRCall());
#endif

  const XalanDOMString rinit("init");
	XSLTProcessorEnvSupportDefault::installExternalFunctionGlobal(
		theNamespace,
		rinit,
		RInitFunction());


 char *funcNames[] = {"eval", "source", "sqrt", "date", "histogram"};
 char *internalFuncNames[] = {"XSLParseEval", "Source", NULL, NULL, NULL};
 for(int i = 0; i < sizeof(funcNames)/sizeof(funcNames[0]); i++) {
    XalanDOMString xslName(funcNames[i]); 
	XSLTProcessorEnvSupportDefault::installExternalFunctionGlobal(
		theNamespace,
		xslName,
		NamedRFunction(internalFuncNames[i] ? internalFuncNames[i] : funcNames[i]));
 }

  return(2);
}

